Index: main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/tests/test_browser.py
===================================================================
--- main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/tests/test_browser.py	(revision 9168)
+++ main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/tests/test_browser.py	(revision 9169)
@@ -118,4 +118,5 @@
         self.manage_clearance_path = self.student_path + '/manage_clearance'
         self.edit_personal_path = self.student_path + '/edit_personal'
+        self.manage_personal_path = self.student_path + '/manage_personal'
         self.studycourse_path = self.student_path + '/studycourse'
         self.payments_path = self.student_path + '/payments'
@@ -170,5 +171,5 @@
         self.app['faculties']['fac1']['dep1'].courses.addCourse(
             self.course)
-        self.app['faculties']['fac1']['dep1'].certificates['CERT1'].addCourseRef(
+        self.app['faculties']['fac1']['dep1'].certificates['CERT1'].addCertCourse(
             self.course, level=100)
 
@@ -454,4 +455,8 @@
         self.assertEqual(self.browser.headers['Status'], '200 Ok')
         self.assertEqual(self.browser.url, self.personal_path)
+        self.browser.getLink("Manage").click()
+        self.assertEqual(self.browser.headers['Status'], '200 Ok')
+        self.assertEqual(self.browser.url, self.manage_personal_path)
+        self.browser.open(self.personal_path)
         self.browser.getLink("Edit").click()
         self.assertEqual(self.browser.headers['Status'], '200 Ok')
@@ -474,5 +479,5 @@
         self.assertEqual(self.browser.headers['Status'], '200 Ok')
         self.assertEqual(self.browser.url, self.history_path)
-        self.assertMatches('...Student admitted by Manager...',
+        self.assertMatches('...Admitted by Manager...',
                            self.browser.contents)
         # Only the Application Slip does not exist
@@ -754,5 +759,5 @@
         self.assertEqual(student['studycourse'].current_session, 2005) # +1
         self.assertEqual(student['studycourse'].current_level, 200) # +100
-        self.assertEqual(student['studycourse'].current_verdict, 'NY') # NY = not set
+        self.assertEqual(student['studycourse'].current_verdict, '0') # 0 = Zero = not set
         self.assertEqual(student['studycourse'].previous_verdict, 'A')
         self.browser.getControl(name="transition").value = ['register_courses']
@@ -762,4 +767,20 @@
         self.browser.getControl(name="transition").value = ['return']
         self.browser.getControl("Save").click()
+        return
+
+    def test_manage_pg_workflow(self):
+        # Managers can pass through the whole workflow
+        IWorkflowState(self.student).setState('school fee paid')
+        self.browser.addHeader('Authorization', 'Basic mgr:mgrpw')
+        student = self.app['students'][self.student_id]
+        self.browser.open(self.manage_student_path)
+        self.assertTrue('<option value="reset6">' in self.browser.contents)
+        self.assertTrue('<option value="register_courses">' in self.browser.contents)
+        self.assertTrue('<option value="reset5">' in self.browser.contents)
+        self.certificate.study_mode = 'pg_ft'
+        self.browser.open(self.manage_student_path)
+        self.assertFalse('<option value="reset6">' in self.browser.contents)
+        self.assertFalse('<option value="register_courses">' in self.browser.contents)
+        self.assertTrue('<option value="reset5">' in self.browser.contents)
         return
 
@@ -776,10 +797,10 @@
         self.browser.addHeader('Authorization', 'Basic mgr:mgrpw')
         self.browser.open(datacenter_path)
-        self.browser.getLink('Upload CSV file').click()
+        self.browser.getLink('Upload data').click()
         filecontents = StringIO(open('students.csv', 'rb').read())
         filewidget = self.browser.getControl(name='uploadfile:file')
         filewidget.add_file(filecontents, 'text/plain', 'students.csv')
         self.browser.getControl(name='SUBMIT').click()
-        self.browser.getLink('Batch processing').click()
+        self.browser.getLink('Process data').click()
         button = lookup_submit_value(
             'select', 'students_zope.mgr.csv', self.browser)
@@ -802,10 +823,10 @@
 """)
         self.browser.open(datacenter_path)
-        self.browser.getLink('Upload CSV file').click()
+        self.browser.getLink('Upload data').click()
         filecontents = StringIO(open('studycourses.csv', 'rb').read())
         filewidget = self.browser.getControl(name='uploadfile:file')
         filewidget.add_file(filecontents, 'text/plain', 'studycourses.csv')
         self.browser.getControl(name='SUBMIT').click()
-        self.browser.getLink('Batch processing').click()
+        self.browser.getLink('Process data').click()
         button = lookup_submit_value(
             'select', 'studycourses_zope.mgr.csv', self.browser)
@@ -917,5 +938,5 @@
         self.assertTrue('clearance started' in self.browser.contents)
         self.browser.open(self.history_path)
-        self.assertTrue("Reset to 'clearance' by My Public Name" in
+        self.assertTrue("Reset to 'clearance started' by My Public Name" in
             self.browser.contents)
         IWorkflowInfo(self.student).fireTransition('request_clearance')
@@ -946,5 +967,5 @@
         self.app['users'].addUser('mrsadvise', 'mrsadvisesecret')
         self.app['users']['mrsadvise'].email = 'mradvise@foo.ng'
-        self.app['users']['mrsadvise'].title = 'Helen Procter'
+        self.app['users']['mrsadvise'].title = u'Helen Procter'
         # Assign local CourseAdviser100 role for a certificate
         cert = self.app['faculties']['fac1']['dep1'].certificates['CERT1']
@@ -997,11 +1018,11 @@
         # the 100L CA does see the 'Validate' button
         self.browser.open(L110_student_path)
-        self.assertFalse('Validate' in self.browser.contents)
+        self.assertFalse('Validate courses' in self.browser.contents)
         IWorkflowInfo(self.student).fireTransition('register_courses')
         self.browser.open(L110_student_path)
-        self.assertFalse('Validate' in self.browser.contents)
+        self.assertFalse('Validate courses' in self.browser.contents)
         self.student['studycourse'].current_level = 110
         self.browser.open(L110_student_path)
-        self.assertTrue('Validate' in self.browser.contents)
+        self.assertTrue('Validate courses' in self.browser.contents)
         # ... but a 100L CA does not see the button on other levels
         studylevel2 = StudentStudyLevel()
@@ -1011,9 +1032,15 @@
         L200_student_path = self.studycourse_path + '/200'
         self.browser.open(L200_student_path)
-        self.assertFalse('Validate' in self.browser.contents)
+        self.assertFalse('Validate courses' in self.browser.contents)
         self.browser.open(L110_student_path)
         self.browser.getLink("Validate courses").click()
         self.assertTrue('Course list has been validated' in self.browser.contents)
         self.assertTrue('courses validated' in self.browser.contents)
+        self.assertEqual(self.student['studycourse']['110'].validated_by,
+            'Helen Procter')
+        self.assertMatches(
+            '<YYYY-MM-DD hh:mm:ss>',
+            self.student['studycourse']['110'].validation_date.strftime(
+                "%Y-%m-%d %H:%M:%S"))
         self.browser.getLink("Reject courses").click()
         self.assertTrue('Course list request has been annulled.'
@@ -1023,4 +1050,6 @@
             '/contactstudent?subject=%s' % urlmessage)
         self.assertTrue('school fee paid' in self.browser.contents)
+        self.assertTrue(self.student['studycourse']['110'].validated_by is None)
+        self.assertTrue(self.student['studycourse']['110'].validation_date is None)
         IWorkflowInfo(self.student).fireTransition('register_courses')
         self.browser.open(L110_student_path)
@@ -1142,8 +1171,16 @@
         # and can perform actions
         IWorkflowInfo(self.student).fireTransition('admit')
+        # Students can't login if their account is suspended/deactivated
+        self.student.suspended = True
         self.browser.open(self.login_path)
         self.browser.getControl(name="form.login").value = self.student_id
         self.browser.getControl(name="form.password").value = 'spwd'
         self.browser.getControl("Login").click()
+        self.assertTrue(
+            'Your account has been deactivated.' in self.browser.contents)
+        self.student.suspended = False
+        self.browser.getControl("Login").click()
+        self.assertTrue(
+            'You logged in.' in self.browser.contents)
         # Student can upload a passport picture
         self.browser.open(self.student_path + '/change_portrait')
@@ -1170,5 +1207,7 @@
         self.assertMatches('...Not all required fields filled...',
                            self.browser.contents)
-        self.student.email = 'aa@aa.ng'
+        self.browser.open(self.student_path + '/edit_base')
+        self.browser.getControl(name="form.email").value = 'aa@aa.ng'
+        self.browser.getControl("Save").click()
         self.browser.open(self.student_path + '/start_clearance')
         self.browser.getControl(name="ac_series").value = '3'
@@ -1185,4 +1224,7 @@
         # Set the correct owner
         self.existing_clrac.owner = self.student_id
+        # clr_code might be set (and thus returns None) due importing
+        # an empty clr_code column.
+        self.student.clr_code = None
         self.browser.getControl("Start clearance now").click()
         self.assertMatches('...Clearance process has been started...',
@@ -1235,5 +1277,5 @@
         self.browser.getControl("Create course list now").click()
         self.browser.getLink("100").click()
-        self.browser.getLink("Add and remove courses").click()
+        self.browser.getLink("Edit course list").click()
         self.browser.getControl("Add course ticket").click()
         self.browser.getControl(name="form.course").value = ['COURSE1']
@@ -1248,5 +1290,5 @@
         self.browser.getControl("Create course list now").click()
         self.browser.getLink("200").click()
-        self.browser.getLink("Add and remove courses").click()
+        self.browser.getLink("Edit course list").click()
         self.browser.getControl("Add course ticket").click()
         self.browser.getControl(name="form.course").value = ['COURSE1']
@@ -1286,4 +1328,17 @@
         self.assertEqual(self.student.state, 'courses registered')
         return
+
+    def test_student_clearance_wo_clrcode(self):
+        IWorkflowState(self.student).setState('clearance started')
+        self.browser.open(self.login_path)
+        self.browser.getControl(name="form.login").value = self.student_id
+        self.browser.getControl(name="form.password").value = 'spwd'
+        self.browser.getControl("Login").click()
+        self.student.clearance_locked = False
+        self.browser.open(self.edit_clearance_path)
+        self.browser.getControl(name="form.date_of_birth").value = '09/10/1961'
+        self.browser.getControl("Save and request clearance").click()
+        self.assertMatches('...Clearance has been requested...',
+                           self.browser.contents)
 
     def test_manage_payments(self):
@@ -1516,5 +1571,5 @@
         # The new SFE-0 pin can be used for starting new session
         self.browser.open(self.studycourse_path)
-        self.browser.getLink('Start session').click()
+        self.browser.getLink('Start new session').click()
         pin = self.app['accesscodes']['SFE-0'].keys()[0]
         parts = pin.split('-')[1:]
@@ -1528,5 +1583,57 @@
         return
 
-    def test_postgraduate_payments(self):
+    def test_student_previous_payments(self):
+        # Login
+        self.browser.open(self.login_path)
+        self.browser.getControl(name="form.login").value = self.student_id
+        self.browser.getControl(name="form.password").value = 'spwd'
+        self.browser.getControl("Login").click()
+
+        # Students can add previous school fee payment tickets in any state.
+        IWorkflowState(self.student).setState('courses registered')
+        self.browser.open(self.payments_path)
+        self.browser.getControl("Add online payment ticket").click()
+        self.browser.getControl(name="form.p_category").value = ['schoolfee']
+        self.browser.getControl("Create ticket").click()
+
+        # Amount cannot be determined since the state is not
+        # 'cleared' or 'returning'
+        self.assertMatches('...Amount could not be determined...',
+                           self.browser.contents)
+        self.assertMatches('...Would you like to pay for a previous session?...',
+                           self.browser.contents)
+
+        # Previous session payment form is provided
+        self.browser.getControl(name="form.p_category").value = ['schoolfee']
+        self.browser.getControl(name="form.p_session").value = ['2004']
+        self.browser.getControl(name="form.p_level").value = ['300']
+        self.browser.getControl("Create ticket").click()
+        self.assertMatches('...ticket created...',
+                           self.browser.contents)
+        ctrl = self.browser.getControl(name='val_id')
+        value = ctrl.options[0]
+        self.browser.getLink(value).click()
+        self.assertMatches('...Amount Authorized...',
+                           self.browser.contents)
+        self.assertEqual(self.student['payments'][value].amount_auth, 20000.0)
+
+        # Payment session is properly set
+        self.assertEqual(self.student['payments'][value].p_session, 2004)
+        self.assertEqual(self.student['payments'][value].p_level, 300)
+
+        # We simulate the approval
+        self.browser.open(self.browser.url + '/fake_approve')
+        self.assertMatches('...Payment approved...',
+                          self.browser.contents)
+
+        # No AC has been created
+        self.assertEqual(len(self.app['accesscodes']['SFE-0'].keys()), 0)
+        self.assertTrue(self.student['payments'][value].ac is None)
+
+        # Current payment flag is set False
+        self.assertFalse(self.student['payments'][value].p_current)
+        return
+
+    def test_student_postgraduate_payments(self):
         self.certificate.study_mode = 'pg_ft'
         self.certificate.start_level = 999
@@ -1552,5 +1659,5 @@
                            self.browser.contents)
         # Payment session and level are current ones.
-        # Postgrads have to school_fee_1.
+        # Postgrads have to pay school_fee_1.
         self.assertEqual(self.student['payments'][value].amount_auth, 40000.0)
         self.assertEqual(self.student['payments'][value].p_session, 2004)
@@ -1565,5 +1672,5 @@
         # The new SFE-0 pin can be used for starting session
         self.browser.open(self.studycourse_path)
-        self.browser.getLink('Start session').click()
+        self.browser.getLink('Start new session').click()
         pin = self.app['accesscodes']['SFE-0'].keys()[0]
         parts = pin.split('-')[1:]
@@ -1605,5 +1712,5 @@
         # The new SFE-1 pin can be used for starting new session
         self.browser.open(self.studycourse_path)
-        self.browser.getLink('Start session').click()
+        self.browser.getLink('Start new session').click()
         self.browser.getControl(name="ac_series").value = sfeseries
         self.browser.getControl(name="ac_number").value = sfenumber
@@ -1850,21 +1957,4 @@
         self.assertTrue('An email with' in self.browser.contents)
 
-    def test_reindex(self):
-        self.browser.addHeader('Authorization', 'Basic mgr:mgrpw')
-        self.browser.open('http://localhost/app/reindex')
-        self.assertTrue('No catalog name provided' in self.browser.contents)
-        self.browser.open('http://localhost/app/reindex?ctlg=xyz')
-        self.assertTrue('xyz_catalog does not exist' in self.browser.contents)
-        cat = queryUtility(ICatalog, name='students_catalog')
-        results = cat.searchResults(student_id=(None, None))
-        self.assertEqual(len(results),1)
-        cat.clear()
-        results = cat.searchResults(student_id=(None, None))
-        self.assertEqual(len(results),0)
-        self.browser.open('http://localhost/app/reindex?ctlg=students')
-        self.assertTrue('1 students re-indexed' in self.browser.contents)
-        results = cat.searchResults(student_id=(None, None))
-        self.assertEqual(len(results),1)
-
     def test_change_current_mode(self):
         self.browser.addHeader('Authorization', 'Basic mgr:mgrpw')
@@ -1888,4 +1978,112 @@
         self.assertTrue('Employer' in self.browser.contents)
 
+    def test_activate_deactivate_buttons(self):
+        self.browser.addHeader('Authorization', 'Basic mgr:mgrpw')
+        self.browser.open(self.student_path)
+        self.browser.getLink("Deactivate").click()
+        self.assertTrue(
+            'Student account has been deactivated.' in self.browser.contents)
+        self.assertTrue(
+            'Base Data (account deactivated)' in self.browser.contents)
+        self.assertTrue(self.student.suspended)
+        self.browser.getLink("Activate").click()
+        self.assertTrue(
+            'Student account has been activated.' in self.browser.contents)
+        self.assertFalse(
+            'Base Data (account deactivated)' in self.browser.contents)
+        self.assertFalse(self.student.suspended)
+        # History messages have been added ...
+        self.browser.getLink("History").click()
+        self.assertTrue(
+            'Student account deactivated by Manager<br />' in self.browser.contents)
+        self.assertTrue(
+            'Student account activated by Manager<br />' in self.browser.contents)
+        # ... and actions have been logged.
+        logfile = os.path.join(
+            self.app['datacenter'].storage, 'logs', 'students.log')
+        logcontent = open(logfile).read()
+        self.assertTrue('zope.mgr - students.browser.StudentDeactivatePage - '
+                        'K1000000 - account deactivated' in logcontent)
+        self.assertTrue('zope.mgr - students.browser.StudentActivatePage - '
+                        'K1000000 - account activated' in logcontent)
+
+    def test_student_transfer(self):
+        # Add second certificate
+        self.certificate2 = createObject('waeup.Certificate')
+        self.certificate2.code = u'CERT2'
+        self.certificate2.study_mode = 'ug_ft'
+        self.certificate2.start_level = 999
+        self.certificate2.end_level = 999
+        self.app['faculties']['fac1']['dep1'].certificates.addCertificate(
+            self.certificate2)
+
+        # Add study level to old study course
+        studylevel = createObject(u'waeup.StudentStudyLevel')
+        studylevel.level = 200
+        self.student['studycourse'].addStudentStudyLevel(
+            self.certificate, studylevel)
+
+        self.browser.addHeader('Authorization', 'Basic mgr:mgrpw')
+        self.browser.open(self.student_path)
+        self.browser.getLink("Transfer").click()
+        self.browser.getControl(name="form.certificate").value = ['CERT2']
+        self.browser.getControl(name="form.current_session").value = ['2011']
+        self.browser.getControl(name="form.current_level").value = ['200']
+        self.browser.getControl("Transfer").click()
+        self.assertTrue(
+            'Current level does not match certificate levels'
+            in self.browser.contents)
+        self.browser.getControl(name="form.current_level").value = ['999']
+        self.browser.getControl("Transfer").click()
+        self.assertTrue('Successfully transferred' in self.browser.contents)
+
+        # Add study level to new study course
+        studylevel = createObject(u'waeup.StudentStudyLevel')
+        studylevel.level = 200
+        self.student['studycourse'].addStudentStudyLevel(
+            self.certificate, studylevel)
+
+        # Edit and add pages are locked for old study courses
+        self.browser.open(self.student_path + '/studycourse/manage')
+        self.assertFalse('The requested form is locked' in self.browser.contents)
+        self.browser.open(self.student_path + '/studycourse_1/manage')
+        self.assertTrue('The requested form is locked' in self.browser.contents)
+
+        self.browser.open(self.student_path + '/studycourse/start_session')
+        self.assertFalse('The requested form is locked' in self.browser.contents)
+        self.browser.open(self.student_path + '/studycourse_1/start_session')
+        self.assertTrue('The requested form is locked' in self.browser.contents)
+
+        IWorkflowState(self.student).setState('school fee paid')
+        self.browser.open(self.student_path + '/studycourse/add')
+        self.assertFalse('The requested form is locked' in self.browser.contents)
+        self.browser.open(self.student_path + '/studycourse_1/add')
+        self.assertTrue('The requested form is locked' in self.browser.contents)
+
+        self.browser.open(self.student_path + '/studycourse/200/manage')
+        self.assertFalse('The requested form is locked' in self.browser.contents)
+        self.browser.open(self.student_path + '/studycourse_1/200/manage')
+        self.assertTrue('The requested form is locked' in self.browser.contents)
+
+        self.browser.open(self.student_path + '/studycourse/200/validate_courses')
+        self.assertFalse('The requested form is locked' in self.browser.contents)
+        self.browser.open(self.student_path + '/studycourse_1/200/validate_courses')
+        self.assertTrue('The requested form is locked' in self.browser.contents)
+
+        self.browser.open(self.student_path + '/studycourse/200/reject_courses')
+        self.assertFalse('The requested form is locked' in self.browser.contents)
+        self.browser.open(self.student_path + '/studycourse_1/200/reject_courses')
+        self.assertTrue('The requested form is locked' in self.browser.contents)
+
+        self.browser.open(self.student_path + '/studycourse/200/add')
+        self.assertFalse('The requested form is locked' in self.browser.contents)
+        self.browser.open(self.student_path + '/studycourse_1/200/add')
+        self.assertTrue('The requested form is locked' in self.browser.contents)
+
+        self.browser.open(self.student_path + '/studycourse/200/edit')
+        self.assertFalse('The requested form is locked' in self.browser.contents)
+        self.browser.open(self.student_path + '/studycourse_1/200/edit')
+        self.assertTrue('The requested form is locked' in self.browser.contents)
+
 class StudentRequestPWTests(StudentsFullSetup):
     # Tests for student registration
@@ -1894,10 +2092,10 @@
 
     def test_request_pw(self):
-        # Student with wrong reg_number can't be found.
+        # Student with wrong number can't be found.
         self.browser.open('http://localhost/app/requestpw')
         self.browser.getControl(name="form.firstname").value = 'Anna'
-        self.browser.getControl(name="form.reg_number").value = 'anynumber'
+        self.browser.getControl(name="form.number").value = 'anynumber'
         self.browser.getControl(name="form.email").value = 'xx@yy.zz'
-        self.browser.getControl("Get login credentials").click()
+        self.browser.getControl("Send login credentials").click()
         self.assertTrue('No student record found.'
             in self.browser.contents)
@@ -1906,7 +2104,7 @@
         self.browser.open('http://localhost/app/requestpw')
         self.browser.getControl(name="form.firstname").value = 'Johnny'
-        self.browser.getControl(name="form.reg_number").value = '123'
+        self.browser.getControl(name="form.number").value = '123'
         self.browser.getControl(name="form.email").value = 'xx@yy.zz'
-        self.browser.getControl("Get login credentials").click()
+        self.browser.getControl("Send login credentials").click()
         self.assertTrue('No student record found.'
             in self.browser.contents)
@@ -1914,6 +2112,6 @@
         # password has been set and used.
         self.browser.getControl(name="form.firstname").value = 'Anna'
-        self.browser.getControl(name="form.reg_number").value = '123'
-        self.browser.getControl("Get login credentials").click()
+        self.browser.getControl(name="form.number").value = '123'
+        self.browser.getControl("Send login credentials").click()
         self.assertTrue('Your password has already been set and used.'
             in self.browser.contents)
@@ -1922,8 +2120,16 @@
         # The firstname field, used for verification, is not case-sensitive.
         self.browser.getControl(name="form.firstname").value = 'aNNa'
-        self.browser.getControl(name="form.reg_number").value = '123'
+        self.browser.getControl(name="form.number").value = '123'
         self.browser.getControl(name="form.email").value = 'new@yy.zz'
-        self.browser.getControl("Get login credentials").click()
+        self.browser.getControl("Send login credentials").click()
         # Yeah, we succeded ...
+        self.assertTrue('Your password request was successful.'
+            in self.browser.contents)
+        # We can also use the matric_number instead.
+        self.browser.open('http://localhost/app/requestpw')
+        self.browser.getControl(name="form.firstname").value = 'aNNa'
+        self.browser.getControl(name="form.number").value = '234'
+        self.browser.getControl(name="form.email").value = 'new@yy.zz'
+        self.browser.getControl("Send login credentials").click()
         self.assertTrue('Your password request was successful.'
             in self.browser.contents)
@@ -1934,3 +2140,8 @@
             email=('new@yy.zz', 'new@yy.zz')))
         self.assertEqual(self.student,results[0])
+        logfile = os.path.join(
+            self.app['datacenter'].storage, 'logs', 'main.log')
+        logcontent = open(logfile).read()
+        self.assertTrue('zope.anybody - students.browser.StudentRequestPasswordPage - '
+                        '234 (K1000000) - new@yy.zz' in logcontent)
         return
Index: main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/tests/test_dynamicroles.py
===================================================================
--- main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/tests/test_dynamicroles.py	(revision 9168)
+++ main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/tests/test_dynamicroles.py	(revision 9169)
@@ -25,4 +25,5 @@
     Test as APRMTest, Manageable)
 from waeup.kofa.testing import FunctionalLayer
+from waeup.kofa.app import University
 from waeup.kofa.students.tests.test_browser import StudentsFullSetup
 from waeup.kofa.students import Student, StudentPrincipalRoleManager
@@ -48,8 +49,9 @@
     def setUp(self):
         super(StudentPrincipalRoleManagerFunctionalTests, self).setUp()
-        self.officer_role = 'waeup.StudentsClearanceOfficer'
         # assign clearance permissions for a virtual officer
         prm = IPrincipalRoleManager(self.app['faculties']['fac1']['dep1'])
         prm.assignRoleToPrincipal('waeup.local.ClearanceOfficer', 'alice')
+        prm.assignRoleToPrincipal('waeup.local.PGClearanceOfficer', 'bob')
+        prm.assignRoleToPrincipal('waeup.local.UGClearanceOfficer', 'anne')
         return
 
@@ -74,5 +76,5 @@
         # student
         prm = IPrincipalRoleManager(self.student)
-        result = prm.getRolesForPrincipal('bob')
+        result = prm.getRolesForPrincipal('claus')
         self.assertEqual(result, [])
         return
@@ -83,4 +85,18 @@
         prm = IPrincipalRoleManager(self.student)
         result = prm.getRolesForPrincipal('alice')
-        self.assertEqual(result, [(self.officer_role, Allow)])
+        self.assertEqual(result, [('waeup.StudentsClearanceOfficer', Allow)])
+        # Student is a UG student
+        self.assertFalse(self.student.is_postgrad)
+        result = prm.getRolesForPrincipal('bob')
+        self.assertEqual(result, [('waeup.StudentsOfficer', Allow)])
+        result = prm.getRolesForPrincipal('anne')
+        self.assertEqual(result, [('waeup.StudentsClearanceOfficer', Allow)])
+        # Make student a PG student
+        self.certificate.study_mode = u'pg_ft'
+        self.assertTrue(self.student.is_postgrad)
+        result = prm.getRolesForPrincipal('bob')
+        # The dynamic roles changed
+        self.assertEqual(result, [('waeup.StudentsClearanceOfficer', Allow)])
+        result = prm.getRolesForPrincipal('anne')
+        self.assertEqual(result, [('waeup.StudentsOfficer', Allow)])
         return
